// Search mask for UnrealShare.ScriptedPawn.SetEnemy()
//82 , 72 , 2E , 9 bytes , 2A , 16 , 18 , 2 bytes (unknown), 72 , 2E , 9 bytes , 2A , 16, 16

//We need this line
// if ( !NewEnemy.bIsPlayer && ScriptedPawn(NewEnemy) == none )
//Instead of
// if ( (PlayerPawn(NewEnemy) == None) && (ScriptedPawn(NewEnemy) == None) )

void UXC_GameEngine::ReplaceSetEnemyFunc( UBOOL bSet)
{
	guard(UXC_GameEngine::ReplaceSetEnemyFunc);
	if ( (bSetEnemy && bSet) || (!bSetEnemy && !bSet) )
		return;
	UClass* ScriptedPawn = NULL;
	for( TObjectIterator<UClass> It; It; ++It )
		if( It->GetOuter() && (appStricmp( It->GetOuter()->GetName(), TEXT("UnrealShare") ) == 0) && (appStricmp( It->GetName(), TEXT("ScriptedPawn") ) == 0) )
		{
			ScriptedPawn = *It;
			break;
		}
	if ( !ScriptedPawn )
	{
		bSetEnemy = 0;
		return;
	}

	UFunction* SetEnemy = FindBaseFunction( ScriptedPawn, TEXT("SetEnemy") );
//	if ( !SetEnemy ) //ASSUMED
//		return;

	if ( OldSetEnemy.IsCleared() && (!bSet || !OldSetEnemy.Setup( &SetEnemy->Script )) )
		return;

	if ( !bSet )
	{
		OldSetEnemy.Restore( &SetEnemy->Script);
		OldSetEnemy.Clear();
		if ( bEnableDebugLogs )
			debugf( NAME_XC_Engine, TEXT("Reverting ScriptedPawn.SetEnemy hook") );
		bSetEnemy = 0;
		return;
	}

	if ( !bUseSetEnemyHook )
		return;

	//Initialize remaining vars
	INT Found = 0;
	UProperty* bIsPlayer = FindScriptVariable( APawn::StaticClass(), TEXT("bIsPlayer"), &Found);
	UProperty* NewEnemy = FindScriptVariable( SetEnemy, TEXT("NewEnemy"), &Found);
	check( Found == 2 );

	//Find the line we have to replace
	INT LoopCount = 80; //v436 code is at location 113, but we're keeping this for version compatibility
	BYTE* Block = &SetEnemy->Script( LoopCount );
	while ( true )
	{
		if ( (*Block == 0x82) && (*(Block+1) == 0x72) && (*(Block+2) == 0x2E)
		 && (*(Block+12) == 0x2A) && (*(Block+13) == 0x16) && (*(Block+14) == 0x18)
		 && (*(Block+17) == 0x72) && (*(Block+18) == 0x2E) && (*(Block+28) == 0x2A) 
		 && (*(Block+29) == 0x16) && (*(Block+30) == 0x16) && (*(Block-3) == 0x07) )
		{
			break;
		}
		if ( LoopCount++ >= 150 ) //We didn't find the code
			return;
		Block++;
	}
	_WORD JumpBackOffset = *(	(_WORD*)	(Block-2)	); //146 in v436 UT
	_WORD JumpForwardOffset = (_WORD) SetEnemy->Script.Num();
	*(Block-3) = 0x06; //Change EX_JumpIfNot to EX_Jump
	appMemcpy( Block-2, &JumpForwardOffset, 2); //Jump to byte after end of function
	for ( LoopCount=0 ; LoopCount < 33 ; LoopCount++ )
		*Block++ = 0x0B;	//Clear out the whole line + return false with EX_Nothing
	SetEnemy->Script.Add(42); //Reallocation occurred, we need to reset Block
	Block = &SetEnemy->Script(0) + JumpForwardOffset;
	JumpToIfNot( Block, JumpBackOffset); Block += 3; // (3)
	*Block++ = 0x82; // && (4)
	*Block++ = 0x81; // ! (5)
	*Block++ = 0x19; // EX_Context (6)
	ParseLocalVariable( Block, NewEnemy); Block += 5;// (11)
	*Block++ = 0x06; // context stuff
	*Block++ = 0x00; // context stuff
	*Block++ = 0x04; // context stuff (14)
	*Block++ = 0x2D; // EX_BoolVariable (15)
	ParseInstanceVariable( Block, bIsPlayer); Block += 5;// (20)
	*Block++ = 0x16; // EX_EndFunctionParms (21)
	*Block++ = 0x18; // EX_Skip (22)
	*Block++ = 0x0E; // (23)
	*Block++ = 0x00; // (24)
	*Block++ = 0x72; // == (25)
	*Block++ = 0x2E; // EX_DynamicCast (26)
	appMemcpy( Block, &ScriptedPawn, 4); Block += 4;// (30)
	ParseLocalVariable( Block, NewEnemy); Block += 5;// (35)
	*Block++ = 0x2A; // EX_NoObject (36)
	*Block++ = 0x16; // EX_EndFunctionParms (37)
	*Block++ = 0x16; // EX_EndFunctionParms (38)
	*Block++ = 0x04; // Return command (39)
	*Block++ = 0x28; // False value (40)
	AddReturn( Block); //42 - THIS IS A SAFETY RETURN

	bSetEnemy = 1;
	if ( bEnableDebugLogs )
		debugf( NAME_XC_Engine, TEXT("ScriptedPawn.SetEnemy hook success"));
	unguard;
}